
                        //     ___
#BIT RES=0x07.3         //     RES  pin Reset
                        //       _
#BIT D_C=0x07.2         //     D/C  pin Data/Comand
                        //     __
#BIT CS=0x08.0          //     CS   pin Chip Select 
#BIT SCK=0x07.1         //     SCK  pin Serial Clock
#BIT SDA=0x07.0         //     SDA  pin Serial Data

                        //     ___
#BIT RES_TRIS=0x78.3    //     RES_TRIS  pin Reset
                        //       _
#BIT D_C_TRIS=0x87.2    //     D/C_TRIS  pin Data/Comand
                        //     __
#BIT CS_TRIS=0x88.0     //     CS_TRIS   pin Chip Select 
#BIT SCK_TRIS=0x87.1    //     SCK_TRIS  pin Serial Clock
#BIT SDA_TRIS=0x87.0    //     SDA_TRIS  pin Serial Data

//#define M350_Com(x) { D_C=0; M350_TRS(x);}
//#define M350_Dat(x) { D_C=1; M350_TRS(x);}
#define M350_Reset {RES=0;delay_us(15);RES=1;}
#define Normal_Display       M350_Com(0b10100110)
#define Invers_Display       M350_Com(0b10100111)
#define Display_On           M350_Com(0b10101111)
#define Display_Off          M350_Com(0b10101110)  //(POR)
#define M350_Exit_sleep_Mod  M350_Com(0b10010100)
#define M350_Entr_sleep_Mod  M350_Com(0b10010101)  //(POR)
#define M350_Fill_Enable     {M350_Com(0b10010010);M350_Dat(1);}
#define M350_Fill_Disable    {M350_Com(0b10010010);M350_Dat(0);}
////////////////////////////////////////////////////////////////////////////////
void M350_INIT()
{

 RES_TRIS=0;
 D_C_TRIS=0;
 CS_TRIS=0;
 SCK_TRIS=0;
 SDA_TRIS=0;
 D_C=0;
 CS=0;
 SCK=0;
 SDA=0;
 RES=1; 
}
////////////////////////////////////////////////////////////////////////////////
void M350_TRS(unsigned char Data)
////////////////////////////////////////////////////////////////////////////////
{
 unsigned char n=0;
 SCK=0;
 CS=0;
 delay_us(50);
 do
 {
 switch (n)
  {case 0: SDA=Data>>7; n++; break;
   case 1: SDA=(Data<<1)>>7; n++; break;
   case 2: SDA=(Data<<2)>>7; n++; break;
   case 3: SDA=(Data<<3)>>7; n++; break;
   case 4: SDA=(Data<<4)>>7; n++; break;
   case 5: SDA=(Data<<5)>>7; n++; break;
   case 6: SDA=(Data<<6)>>7; n++; break;
   case 7: SDA=Data<<7; n++;
  };
  delay_us(50);
  SCK=1;
  delay_us(20);
  SCK=0;
  
 }while(n<8);
 delay_us(20);
 CS=1;

 delay_us(40);
 SDA=0; 
 
}
////////////////////////////////////////////////////////////////////////////////
void M350_Com(unsigned char Data)
////////////////////////////////////////////////////////////////////////////////
{
 D_C=0; M350_TRS(Data);
}
////////////////////////////////////////////////////////////////////////////////
void M350_Dat(unsigned char Data)
////////////////////////////////////////////////////////////////////////////////
{
 D_C=1; M350_TRS(Data); D_C=0;
}
////////////////////////////////////////////////////////////////////////////////
void Contrast_Level(unsigned char level)
////////////////////////////////////////////////////////////////////////////////
{
 M350_Com(0b10000001);
 M350_Dat(level);         //contrast level 0-64
 M350_Dat(0);             //Regulator Resistor Ratio  000: 2.84 (POR)
}
////////////////////////////////////////////////////////////////////////////////
void Contrast_increm(unsigned char n)
////////////////////////////////////////////////////////////////////////////////
{unsigned char i=0;
 do
 {
 i++;
 M350_Com(0b11010110);
 }while(i<n);
}
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
void Contrast_decrem(unsigned char n)
////////////////////////////////////////////////////////////////////////////////
{unsigned char i=0;
 do
 {
 i++;
 M350_Com(0b11010111);
 }while(i<n);
}
////////////////////////////////////////////////////////////////////////////////
void M350_Write_Display_Data(unsigned char data)
////////////////////////////////////////////////////////////////////////////////
{
 M350_Com(0b01011100);
 M350_Dat(data);
}
////////////////////////////////////////////////////////////////////////////////
void M350_Set_Column_Address(unsigned char start,unsigned char end)
////////////////////////////////////////////////////////////////////////////////
{
 M350_Com(0b00010101);
 M350_Dat(start);         //  In 8-levels gray scale mode, column address is in a range of 0~103
 M350_Dat(end);           //  In 16-level gray scale mode, column address is in a range of 0~51
}
////////////////////////////////////////////////////////////////////////////////
void M350_Set_Page_Address(unsigned char start,unsigned char end)
////////////////////////////////////////////////////////////////////////////////
{
 M350_Com(0b01110101);
 M350_Dat(start);         //  Page address is in a range of 0~79
 M350_Dat(end);           
}
////////////////////////////////////////////////////////////////////////////////
void M350_Draw_Line(unsigned char X1,unsigned char Y1,unsigned char X2,unsigned char Y2,unsigned int16 color)
////////////////////////////////////////////////////////////////////////////////
{
 
 
 M350_Com(0b10000011);   //  Enter the draw line mode
 M350_Dat(X1);
 M350_Dat(Y1);
 M350_Dat(X2);
 M350_Dat(Y2);
 M350_Dat((int8)(color>>4));       //  Color Word ****R3R2R1R0G3G2G1G0B3B2B1B0
 M350_Dat((int8)(color<<12));
}
////////////////////////////////////////////////////////////////////////////////
void M350_Scan_Settings(unsigned char page_column_scan_directions,
                        unsigned char RGB_color_arrangement,
                        unsigned char Gray_scale_modes)
////////////////////////////////////////////////////////////////////////////////
{
 M350_Com(0b10111100);
 M350_Dat(page_column_scan_directions);   // *****XX0: set page address to normal display (POR)
                                          // *****XX1: set page address to inverse display
                                          // *****X0X: set column address to normal rotation (POR)
                                          // *****X1X: set column address to inverse rotation
                                          // *****0XX: set scan direction to column scan (POR)
                                          // *****1XX: set scan direction to page scan

 M350_Dat(RGB_color_arrangement);         // *****000: is (POR) value

 M350_Dat(Gray_scale_modes);              // *****001: 8-levels gray scale mode (POR)
                                          // *****010: 16-levels gray scale mode (Type A)
}
////////////////////////////////////////////////////////////////////////////////
void Draw_rectangle (unsigned char X1,
                     unsigned char Y1,
                     unsigned char X2,
                     unsigned char Y2,
                     unsigned int16 color,
                     unsigned int16 fill_color)
{
 M350_Com(0b10000100);
 M350_Dat(X1);                          //  Remarks: X1<=X2; Y1<=Y2; X2<=103; Y2<=79
 M350_Dat(Y1);
 M350_Dat(X2);
 M350_Dat(Y2);
 M350_Dat((int8)(fill_color>>4));       //  Color Word ****R3R2R1R0G3G2G1G0B3B2B1B0
 M350_Dat((int8)(fill_color<<12));
 M350_Dat((int8)(fill_color>>4));       //  fill_color Word ****R3R2R1R0G3G2G1G0B3B2B1B0
 M350_Dat((int8)(fill_color<<12));
}
////////////////////////////////////////////////////////////////////////////////
void M350_Copy(unsigned char X1,
               unsigned char Y1,
               unsigned char X2,
               unsigned char Y2,
               unsigned char X,
               unsigned char Y )
{
 M350_Com(0b10001010);
 M350_Dat(X1);                          //  Remarks: X1<=X2; Y1<=Y2; X2<=103; Y2<=79
 M350_Dat(Y1);
 M350_Dat(X2);
 M350_Dat(Y2);
 M350_Dat(X);
 M350_Dat(Y);
}
////////////////////////////////////////////////////////////////////////////////
void M350_Dim_Window(unsigned char X1,
                     unsigned char Y1,
                     unsigned char X2,
                     unsigned char Y2)
{
 M350_Com(0b10001100);                   //  The selected window area will be dimmed by 75% white
 M350_Dat(X1);                          //  Remarks: X1<=X2; Y1<=Y2; X2<=103; Y2<=79
 M350_Dat(Y1);
 M350_Dat(X2);
 M350_Dat(Y2);
}
////////////////////////////////////////////////////////////////////////////////
void Clear_Window(unsigned char X1,
                  unsigned char Y1,
                  unsigned char X2,
                  unsigned char Y2)
{
 M350_Com(0b10001110);                   //  X1Y1->X2Y2 All GDDRAM content will be set to 0
 M350_Dat(X1);                          //  Remarks: X1<=X2; Y1<=Y2; X2<=103; Y2<=79
 M350_Dat(Y1);
 M350_Dat(X2);
 M350_Dat(Y2);
}
////////////////////////////////////////////////////////////////////////////////
void Set_Area_Scroll(unsigned char Top_Block,
                     unsigned char Bottom_Block,
                     unsigned char numbers_specified_blocks,
                     unsigned char Scroll_Mode)
{
 M350_Com(0b10101010);                   
 M350_Dat(Top_Block);                  //  **X5X4X3X2X1X0 is used to specify the block address 
                                       //  (1 block = 4 lines) at the top of the scrolling area.
                                       //  Top block address = 000000b (POR)

 M350_Dat(Bottom_Block);               //  **Y5Y4Y3Y2Y1Y0 is used to specify the block address 
                                       //  (1 block = 4 lines) at the bottom of the scrolling area.
                                       //  Bottom block address = 000000b (POR)
                                       
 M350_Dat(numbers_specified_blocks);   //  The number of specified blocks = Number of (Top fixed area + Scroll
                                       //  area) blocks 1
                                       
 M350_Dat(Scroll_Mode);                //  There are four types of area scroll.
                                       //  Scroll_Mode   Types of Area Scroll
                                       //       0        Center Screen Scroll
                                       //       1        Top Screen Scroll
                                       //       2        Bottom Screen Scroll
                                       //       3        Whole Screen Scroll
                                       //  Type of area scroll = Whole Screen Scroll (POR)
}
////////////////////////////////////////////////////////////////////////////////
void Set_Scroll_Start(unsigned char start_block_address)
{
 M350_Com(0b10101011);                   
 M350_Dat(start_block_address);        //  **X5X4X3X2X1X0 specify the start block address
                                       //  (1 block = 4 lines) of area scrolling.
                                       //  Start block address = 000000b (POR)
}
